//Property

#property indicator_chart_window
#property indicator_buffers 10
#property indicator_color1 White
#property indicator_color2 clrDodgerBlue
#property indicator_color3 Red
#property indicator_color4 clrDodgerBlue
#property indicator_color5 Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2

//External Variables

double extern Multiplier = 32.0;
double extern Ticksize = 0.25;
extern double ATR_Period = 10.0;
extern double ATR_DIV = 1.3;
extern int High_Period = 0;
extern int Low_Period = 0;
extern int Smooth_Period = 1; //1 = No Smooth
input ENUM_APPLIED_PRICE Smooth_lowestHigh_Price = PRICE_LOW;
input ENUM_APPLIED_PRICE Smooth_highestLow_Price = PRICE_LOW;
input ENUM_MA_METHOD Smooth_lowestHigh_Type = MODE_SMA;
input ENUM_MA_METHOD Smooth_highestLow_Type = MODE_SMA;
extern string Smooth_Price="Close=0,Open=1,High=2,Low=3,Median=4,Typical=5,Weighted=6";
extern string Smooth_Type="SMA=0,EMA=1,SSMA=2,LWMA=3 ";


bool Trend_Bool;
double IsUpSwingBuffer[];
double UpSwingLineBuffer[];
double DownSwingLineBuffer[];
double Trend_Buffer_Up[];
double Trend_Buffer_Dn[];
double Trend[];
double Value_buffer[];
double lowestHigh_buffer[];
double highestLow_buffer[];
double Trend_Direction[];


//Init Initialization
int init() 
{
SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,2,clrIvory);
SetIndexBuffer(0, IsUpSwingBuffer);
   
SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2);
SetIndexBuffer(1, UpSwingLineBuffer);
SetIndexLabel(1,"UpSwingLine");

SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 2);
SetIndexBuffer(2, DownSwingLineBuffer);
SetIndexLabel(2,"DownSwingLine");

SetIndexBuffer(3, Trend_Buffer_Up);
SetIndexStyle(3,DRAW_ARROW,STYLE_SOLID);
SetIndexArrow(3,233);
SetIndexLabel(3,"Trend_Buff_Up");

SetIndexBuffer(4, Trend_Buffer_Dn);
SetIndexStyle(4,DRAW_ARROW,STYLE_SOLID);
SetIndexArrow(4,234);
SetIndexLabel(4,"Trend_Buff_Dn");

SetIndexBuffer(5, Trend);
SetIndexStyle(5, DRAW_NONE);
SetIndexLabel(5,"Trend");

SetIndexBuffer(6, Value_buffer);
SetIndexStyle(6, DRAW_NONE);
SetIndexLabel(6,"Value_buffer");

SetIndexBuffer(7, highestLow_buffer);
SetIndexStyle(7, DRAW_NONE);
SetIndexLabel(7,"highestLow_buffer");

SetIndexBuffer(8, lowestHigh_buffer);
SetIndexStyle(8, DRAW_NONE);
SetIndexLabel(8,"lowestHigh_buffer");

SetIndexBuffer(9, Trend_Direction);
SetIndexStyle(9, DRAW_NONE);
SetIndexLabel(9,"Trend_Direction");

SetIndexEmptyValue(1, 0.0);
SetIndexEmptyValue(2, 0.0);

Trend_Bool = ((Close[Bars-1]>=Open[Bars-1]) ? true : false);
Trend[Bars-1] = ((Close[Bars-1]>=Open[Bars-1]) ? 1 : 0); 
Value_buffer[Bars-1] = ((Close[Bars-1]>=Open[Bars-1]) ? Low[Bars-1] : High[Bars-1]);

return(0);

}




//START INIT START
int start() 
{
//Initialise Values at the very first historical bar
int start = 0;
int limit;
int counted_bars = IndicatorCounted();

// nothing else to do?
if(counted_bars < 0) 
return(-1);

// do not check repeated bars
limit = Bars - 1 - counted_bars;
  
// Check if ignore bar 0
start = 1;  

// Check the signal foreach bar from past to present
for(int i = limit; i >= start; i--)
{
Trend[i] = 2;
Trend_Direction[i] = Trend_Direction[i+1];
double atr = iATR (NULL, 0, ATR_Period, i) / ATR_DIV;

//lowestHigh_buffer[i] = Low[i];
//highestLow_buffer[i] = High[i];
lowestHigh_buffer[i] = iMA(NULL,0,Smooth_Period,0,Smooth_lowestHigh_Type,Smooth_lowestHigh_Price,i);
highestLow_buffer[i] = iMA(NULL,0,Smooth_Period,0,Smooth_highestLow_Type,Smooth_highestLow_Price,i);

if (Trend_Bool) //equals to true
{ 
double highestLow = MathMax(Value_buffer[i+1],  highestLow_buffer[i] ); 

if (High[i+High_Period] < highestLow - (Ticksize*Multiplier*atr)) 
{ 
Trend_Bool = false;
Value_buffer[i] = lowestHigh_buffer[i];
Trend[i] = 0;
}
else
{
Trend_Bool = true;
Value_buffer[i] = highestLow;
}
} 

if (!Trend_Bool) 
{ 
double lowestHigh = MathMin(Value_buffer[i+1], lowestHigh_buffer[i]); 

if (Low[i+Low_Period] > lowestHigh + (Ticksize*Multiplier*atr)) 
{ 
Trend_Bool = true; 
Value_buffer[i] = highestLow_buffer[i];
Trend[i] = 1; 
} 
else
{
Trend_Bool = false;
Value_buffer[i] = lowestHigh;
}
} 

if (Trend_Bool) 
{
IsUpSwingBuffer[i] = 1.0;
DownSwingLineBuffer[i] = 0.0;
UpSwingLineBuffer[i] = (Low[i]+Low[i+1]+Low[i+2]+Low[i+3])/4;
Trend_Direction[i] = 1;
} 
else 
{
IsUpSwingBuffer[i] = 0.0;
UpSwingLineBuffer[i] = 0.0;
DownSwingLineBuffer[i] = (High[i]+High[i+1]+High[i+2]+High[i+3])/4;
Trend_Direction[i] =-1;
}

if (Trend[i] == 1 && Trend[i+1] ==2)
{
Trend_Buffer_Up[i] = Low[i]-atr*3;
}

if (Trend[i] == 0 && Trend[i+1] ==2)
{
Trend_Buffer_Dn[i] = High[i]+atr*3;
}


} 
return(0);

}
//END INIT START